from Products.validation.interfaces import ivalidator

class LinksValidator:

    __implements__ = (ivalidator,)

    def __init__(self, name):
        self.name = name

# term_or_phrase, link
    def __call__(self, value, *args, **kwargs):
        self.lines = {'term_or_phrase' : [],
                      'link'           : []}
                  
        # setup and check for item count errors:

        line_errors = []
        line_count = 1
        for book_link_string in value:
            term_or_phrase = ""
            link= ""
            try:
                items = eval('[%s]' % book_link_string)
            except:
                return "Mixed numeric and text input somewhere on line %d" % line_count
            if len(items) != 2:
                line_errors.append("%d" % line_count)
            else:
                term_or_phrase, link = items 
                self.lines['term_or_phrase'].append(term_or_phrase)
                self.lines['link'].append(link)
            line_count += 1
        if len(line_errors) > 0:
            return "Wrong number of items on lines: %s" % line_errors

        # check for basic conversion errors:

        error_message = ""
        errors = None

        errors = self.checkForTermOrPhraseErrors()
        if errors:
            error_message = "term_or_phrase (field 1) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForLinkErrors()
        if errors:
            error_message = "link (field 2) error on lines: %s" % str(errors)
            return error_message

        return 1

    def checkForTermOrPhraseErrors(self):
        # pass
        return None

    def checkForLinkErrors(self):
        # pass
        return None
